#include "obj_dir/Vvga.h"
#include "src/app.cc"

int main(int argc, char** argv) {

    int   instr  = 125000;
    float target = 100;

    Verilated::commandArgs(argc, argv);
    App* v386 = new App(argc, argv);

    while (v386->main()) {

        Uint32 start = SDL_GetTicks();

        // Автоматическая коррекция кол-ва инструкции в секунду
        for (int i = 0; i < instr; i++) v386->tick();

        // Коррекция тактов
        Uint32 delay = (SDL_GetTicks() - start);
        instr = (instr * (0.5 * target) / (float)delay);
        instr = instr < 1000 ? 1000 : instr;

        if (Verilated::gotFinish()) break;
    }

    return v386->destroy();
}
